CREATE DATABASE egm_simple_invoice;

USE egm_simple_invoice;

CREATE TABLE `tbl_users` (
  `user_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_created_by` int(11) NOT NULL,
  `user_last_update_by` int(11) DEFAULT NULL,
  `user_full_name` varchar(50) NOT NULL,
  `user_email` varchar(100) NOT NULL,
  `user_gender` enum('Male','Female') NOT NULL,
  `user_status` enum('Active','Inactive') NOT NULL,
  `user_role` enum('Admin','User') NOT NULL,
  `user_password` varchar(150) NOT NULL,
  `user_created_at` datetime NOT NULL,
  `user_updated_at` datetime DEFAULT NULL,
  PRIMARY KEY(user_id)
);

CREATE TABLE `tbl_orders` (
  `order_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_created_by` int(11) NOT NULL,
  `order_last_update_by` int(11) DEFAULT NULL,
  `order_receiver_name` varchar(100) NOT NULL,
  `order_receiver_address` text DEFAULT NULL,
  `order_total_before_tax` decimal(10,2) NOT NULL,
  `order_total_tax` decimal(10,2) NOT NULL,
  `order_total_after_tax` decimal(10,2) NOT NULL,
  `order_note` text DEFAULT NULL,
  `order_created_at` datetime NOT NULL,
  `order_updated_at` datetime DEFAULT NULL,
  PRIMARY KEY(order_id)
);

CREATE TABLE `invoice_order_item` (
  `order_item_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) NOT NULL,
  `item_name` varchar(50) NOT NULL,
  `order_item_quantity` int(10) NOT NULL,
  `order_item_price` decimal(10,2) NOT NULL,
  `order_item_tax_amount` decimal(10,2) NOT NULL,
  `order_item_subtotal_amount` decimal(10,2) NOT NULL,
  `order_item_final_amount` decimal(10,2) NOT NULL,
  PRIMARY KEY(order_item_id)
);

INSERT INTO `tbl_users` (`user_id`, `user_created_by`, `user_last_update_by`, `user_full_name`, `user_email`, `user_gender`, `user_status`, `user_role`, `user_password`, `user_created_at`, `user_updated_at`) VALUES
(1, 1, 1, 'EGavilan Media', 'egavilanmedia@gmail.com', 'Male', 'Active', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-13 02:08:08', '2020-07-19 00:24:39'),
(5, 1, 1, 'Jonas Kanwald', 'jonaskanwald@gmail.com', 'Male', 'Active', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-17 00:00:00', '2020-07-18 00:21:56'),
(6, 1, 1, 'Martha Nielsen', 'mnielsen@gmail.com', 'Female', 'Active', 'User', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-13 05:14:14', '2020-07-18 13:44:21'),
(7, 1, 1, 'Hannah Kahnwald', 'hkahnwald@gmail.com', 'Female', 'Inactive', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-17 00:00:00', '2020-07-18 13:00:42'),
(8, 1, 1, 'Peter Doppler', 'pdoppler@gmail.com', 'Male', 'Active', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-13 05:14:14', '2020-07-18 13:01:39'),
(9, 1, 1, 'Katharina Nielsen', 'knielsen@gmail.com', 'Female', 'Active', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 09:43:02', '2020-07-18 13:04:44'),
(10, 1, 1, 'Bartosz Tiedemann', 'btiedemann@gmail.com', 'Male', 'Active', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 09:45:01', '2020-07-18 13:07:51'),
(11, 1, 1, 'Magnus Nielsen', 'manielsen@gmail.com', 'Male', 'Inactive', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 09:52:06', '2020-07-18 13:09:07'),
(12, 1, 1, 'Ulrich Nielsen', 'unielsen@gmail.com', 'Male', 'Active', 'User', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 09:52:32', '2020-07-18 13:10:12'),
(13, 1, 1, 'Aleksander Tiedemann', 'atiedemann@gmail.com', 'Male', 'Inactive', 'User', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 09:54:55', '2020-07-18 13:11:11'),
(14, 1, 1, 'Franziska Doppler', 'fdoppler@gmail.com', 'Female', 'Inactive', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 09:55:45', '2020-07-18 13:12:08'),
(15, 1, 1, 'Regina Tiedemann', 'rtiedemann@gmail.com', 'Female', 'Active', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 09:56:17', '2020-07-18 13:13:08'),
(16, 1, 1, 'Mikkel Nielsen', 'minielsen@gmail.com', 'Male', 'Active', 'User', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 09:57:02', '2020-07-18 13:14:02'),
(17, 1, 1, 'Claudia Tiedemann', 'ctiedemann@gmail.com', 'Female', 'Inactive', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 09:57:28', '2020-07-18 13:14:50'),
(18, 1, 1, 'Elisabeth Doppler', 'edoppler@gmail.com', 'Female', 'Active', 'User', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 10:15:02', '2020-07-19 08:54:24'),
(19, 1, 1, 'Torben Wöller', 'Woller@gmail.com', 'Male', 'Inactive', 'User', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 10:15:28', '2020-07-18 13:22:21'),
(20, 1, 1, 'Egon Tiedemann', 'etiedemann@gmail.com', 'Male', 'Inactive', 'User', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 10:15:48', '2020-07-18 13:23:13'),
(21, 1, 1, 'Helge Doppler', 'hdoppler@gmail.com', 'Female', 'Active', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 10:16:18', '2020-07-18 13:24:09'),
(22, 1, 1, 'Agnes Nielsen', 'anielsen@gmai.com', 'Female', 'Inactive', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 10:16:44', '2020-07-18 13:25:36'),
(23, 1, 1, 'Greta Doppler', 'gdoppler@gmail.com', 'Female', 'Active', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 10:19:49', '2020-07-18 13:26:43'),
(24, 1, 1, 'Ines Kahnwald', 'ikahnwald@gmail.com', 'Female', 'Inactive', 'User', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 10:20:33', '2020-07-18 13:27:52'),
(25, 1, 1, 'Jürgen Obendorf', 'uobendorf@gmail.com', 'Male', 'Inactive', 'User', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 10:24:08', '2020-07-18 13:28:40'),
(26, 1, 1, 'Bernd Doppler', 'bdoppler@gmail.com', 'Female', 'Inactive', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-21 15:30:46', '2020-07-18 13:37:22'),
(27, 1, 1, 'Erik Obendorf', 'ebendorf@gmail.com', 'Male', 'Active', 'User', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-26 06:04:44', '2020-07-18 13:38:12'),
(28, 1, 1, 'Martin Döhring', 'mdohring@gmail.com', 'Male', 'Active', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-26 06:43:27', '2020-07-18 13:39:08'),
(29, 1, 1, 'Marek Tannhaus', 'mtannhaus@gmail.com', 'Male', 'Active', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-27 08:21:30', '2020-07-18 13:39:53'),
(30, 1, 1, 'H.G. Tannhaus', 'hgtannhaus@gmail.com', 'Male', 'Active', 'Admin', '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', '2020-06-27 20:10:31', '2020-07-18 13:41:58');

INSERT INTO `tbl_orders` (`order_id`, `order_created_by`, `order_last_update_by`, `order_receiver_name`, `order_receiver_address`, `order_total_before_tax`, `order_total_tax`, `order_total_after_tax`, `order_note`, `order_created_at`, `order_updated_at`) VALUES
(1, 1, NULL, 'Louis Hofmann', '', '1284.59', '231.23', '1515.82', 'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.', '2020-07-18 23:58:28', NULL),
(2, 1, NULL, 'Karoline Eichhorn', '', '59.40', '10.69', '70.09', '', '2020-07-18 23:59:44', NULL),
(3, 1, 1, 'Maja Schone', '', '133.77', '24.07', '157.84', '', '2020-07-19 00:00:42', '2020-07-19 00:01:10'),
(4, 5, NULL, 'Moritz Jahn', '', '672.99', '121.15', '794.14', '', '2020-07-19 00:06:09', NULL),
(5, 5, NULL, 'Moritz Jahn', '', '575.70', '103.63', '679.33', '', '2020-07-19 00:11:13', NULL),
(6, 1, 5, 'Paul Lux', '', '5576.00', '1003.68', '6579.68', 'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.', '2020-07-19 00:41:51', '2020-07-19 00:52:33'),
(7, 6, NULL, 'Andreas Pietschmann', '', '437.80', '78.80', '516.60', '', '2020-07-19 08:41:41', NULL),
(8, 6, NULL, 'Maja Schone', '', '5986.30', '1077.53', '7063.83', '', '2020-07-19 08:44:41', NULL),
(9, 6, NULL, 'Karoline Eichhorn', '', '1188.80', '214.00', '1402.80', '', '2020-07-19 08:51:57', NULL),
(10, 18, NULL, 'Moritz Jahn', '', '518.19', '93.27', '611.46', '', '2020-07-19 08:57:45', NULL),
(11, 18, NULL, 'Andreas Pietschmann', '', '1312.65', '236.27', '1548.92', '', '2020-07-19 09:16:09', NULL),
(12, 18, NULL, 'Maja Schone', '', '2288.14', '411.87', '2700.01', '', '2020-07-19 09:32:32', NULL),
(13, 18, NULL, 'Christian Hutcherson', '', '1168.00', '210.24', '1378.24', '', '2020-07-19 09:37:19', NULL);

INSERT INTO `invoice_order_item` (`order_item_id`, `order_id`, `item_name`, `order_item_quantity`, `order_item_price`, `order_item_tax_amount`, `order_item_subtotal_amount`, `order_item_final_amount`) VALUES
(1, 1, 'Eine Reise durch die Zeit - H.G. Tannhaus DARK', 33, '21.89', '130.03', '722.37', '852.40'),
(2, 1, 'Mirror Frame 15 x 10 cm', 10, '29.72', '53.50', '297.20', '350.70'),
(3, 1, 'Dark T-Shirt', 4, '23.78', '17.12', '95.12', '112.24'),
(4, 1, 'Dark netflix, dark Shirt Series', 10, '16.99', '30.58', '169.90', '200.48'),
(5, 2, 'DARK Triquetra | DARK Netflix Keychain', 10, '5.94', '10.69', '59.40', '70.09'),
(7, 3, 'Jonas Minimalist Illustration', 3, '4.99', '2.69', '14.97', '17.66'),
(8, 3, 'ORIGINAL 1986 Pfennig Kette DARK Netflix 1 Pfennig', 10, '11.88', '21.38', '118.80', '140.18'),
(9, 4, 'ORIGINAL 1986 Pfennig Kette DARK Netflix 1 Pfennig', 1, '11.88', '2.14', '11.88', '14.02'),
(10, 4, 'DARK (Netflix) Metal Sign - The Beginning is The E', 1, '30.00', '5.40', '30.00', '35.40'),
(11, 4, 'Dark Series Time Machine Netflix Memorabilia Repli', 1, '533.82', '96.09', '533.82', '629.91'),
(12, 4, 'Dark netflix, dark Shirt Series', 1, '16.99', '3.06', '16.99', '20.05'),
(13, 4, 'DARK Triquetra | DARK Netflix Keychain', 1, '5.94', '1.07', '5.94', '7.01'),
(14, 4, 'DARK - Netflix Lightroom Preset', 1, '3.04', '0.55', '3.04', '3.59'),
(15, 4, 'Dark T-Shirt', 1, '23.78', '4.28', '23.78', '28.06'),
(16, 4, 'Jonas Minimalist Illustration', 1, '4.99', '0.90', '4.99', '5.89'),
(17, 4, 'Mirror Frame 15 x 10 cm  ', 1, '29.72', '5.35', '29.72', '35.07'),
(18, 5, 'ORIGINAL 1986 Pfennig Kette DARK Netflix 1 Pfennig', 1, '11.88', '2.14', '11.88', '14.02'),
(19, 5, 'DARK (Netflix) Metal Sign - The Beginning is The E', 1, '30.00', '5.40', '30.00', '35.40'),
(20, 5, 'Dark Series Time Machine Netflix Memorabilia Repli', 1, '533.82', '96.09', '533.82', '629.91'),
(25, 6, 'Dark T-Shirt', 10, '23.78', '42.80', '237.80', '280.60'),
(26, 6, 'Dark Series Time Machine Netflix Memorabilia Repli', 10, '533.82', '960.88', '5338.20', '6299.08'),
(27, 7, 'Mirror Frame 15 x 10 cm', 10, '10.00', '18.00', '100.00', '118.00'),
(28, 7, 'Jonas Minimalist Illustration', 10, '10.00', '18.00', '100.00', '118.00'),
(29, 7, 'Dark T-Shirt', 10, '23.78', '42.80', '237.80', '280.60'),
(30, 8, 'ORIGINAL 1986 Pfennig Kette DARK Netflix 1 Pfennig', 10, '11.88', '21.38', '118.80', '140.18'),
(31, 8, 'DARK (Netflix) Metal Sign - The Beginning is The E', 10, '30.00', '54.00', '300.00', '354.00'),
(32, 8, 'Dark Series Time Machine Netflix Memorabilia Repli', 10, '533.82', '960.88', '5338.20', '6299.08'),
(33, 8, 'Dark netflix, dark Shirt Series', 10, '16.99', '30.58', '169.90', '200.48'),
(34, 8, 'DARK Triquetra | DARK Netflix Keychain', 6, '10.00', '10.69', '59.40', '70.09'),
(35, 9, 'Mirror Frame 15 x 10 c', 10, '29.72', '53.50', '297.20', '350.70'),
(36, 9, 'Mirror Frame 15 x 10 c', 10, '29.72', '53.50', '297.20', '350.70'),
(37, 9, 'Mirror Frame 15 x 10 c', 10, '29.72', '53.50', '297.20', '350.70'),
(38, 9, 'Mirror Frame 15 x 10 c', 10, '29.72', '53.50', '297.20', '350.70'),
(39, 10, 'Dark netflix, dark Shirt Series', 5, '16.99', '15.29', '84.95', '100.24'),
(40, 10, 'DARK Triquetra | DARK Netflix Keychain', 3, '5.94', '3.21', '17.82', '21.03'),
(41, 10, 'DARK - Netflix Lightroom Preset', 2, '3.04', '1.09', '6.08', '7.17'),
(42, 10, 'Dark T-Shirt', 1, '23.78', '4.28', '23.78', '28.06'),
(43, 10, 'Jonas Minimalist Illustration', 10, '4.99', '8.98', '49.90', '58.88'),
(44, 10, 'Mirror Frame 15 x 10 cm', 10, '29.72', '53.50', '297.20', '350.70'),
(45, 11, 'Potatoes', 3, '34.95', '18.56', '103.10', '121.66'),
(46, 11, 'Coffe 1/2', 1, '114.95', '20.69', '114.95', '135.64'),
(47, 11, 'Atun water', 2, '80.00', '28.80', '160.00', '188.80'),
(48, 11, 'Light 3u', 1, '49.00', '8.82', '49.00', '57.82'),
(49, 11, 'Eggs 12/1', 1, '59.95', '10.79', '59.95', '70.74'),
(50, 11, 'Milk 1lt', 2, '63.95', '23.02', '127.90', '150.92'),
(51, 11, 'Chocorica', 1, '85.00', '15.30', '85.00', '100.30'),
(52, 11, 'Yogurt', 1, '130.00', '23.40', '130.00', '153.40'),
(53, 11, 'Vinagar 32 oz', 1, '39.95', '7.19', '39.95', '47.14'),
(54, 11, 'Peanut 200 G', 1, '127.95', '23.03', '127.95', '150.98'),
(55, 11, 'Honey', 1, '99.95', '17.99', '99.95', '117.94'),
(56, 11, 'Peanut cream 12 oz', 1, '129.95', '23.39', '129.95', '153.34'),
(57, 11, 'Soap 850', 1, '84.95', '15.29', '84.95', '100.24'),
(58, 12, 'CPU AN C2D DDR3', 1, '1991.53', '358.48', '1991.53', '2350.01'),
(59, 12, 'Hard Drive sata 80 GB', 1, '296.61', '53.39', '296.61', '350.00'),
(60, 13, 'TSHIRT STD BLC #M', 2, '95.00', '34.20', '190.00', '224.20'),
(61, 13, 'TSHIRT BLC #M', 1, '116.00', '20.88', '116.00', '136.88'),
(62, 13, 'TSHIRT STD FOXIN RED #M', 1, '126.00', '22.68', '126.00', '148.68'),
(63, 13, 'POLO BLACK #M', 1, '240.00', '43.20', '240.00', '283.20'),
(64, 13, 'POLO FOXIN 50 NAVY', 1, '248.00', '44.64', '248.00', '292.64'),
(65, 13, 'POLO FOXIN 50 RED  # M', 1, '248.00', '44.64', '248.00', '292.64');